ACT_PEELOUT = allocate_mario_action(ACT_GROUP_STATIONARY)


function convert_s16(num)
    local min = -32768
    local max = 32767
    while (num < min) do
        num = max + (num - min)
    end
    while (num > max) do
        num = min + (num - max)
    end
    return num
end


gStateExtras = {}
--Custom Variables
for i=0,(MAX_PLAYERS-1) do
    gStateExtras[i] = {}
    local e = gStateExtras[i]
    
    e.animation = 0
    e.animSpeed = 0
end

function act_peelout(m)
    local stepResult = perform_ground_step(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local e = gStateExtras[m.playerIndex]
    if stepResult ~= GROUND_STEP_LEFT_GROUND then
        m.vel.y = 0
    else
        mario_set_forward_vel(m, m.forwardVel)
        s.lastPosX = m.pos.x
        s.lastPosZ = m.pos.z
        if (m.input & (INPUT_NONZERO_ANALOG)) ~= 0 then
            if analog_stick_held_back(m) ~= 0 then
                pritn("sdsdsdds")
                m.faceAngle.y = m.faceAngle.y + 0x8000
                m.forwardVel = -m.forwardVel
                if m.forwardVel < 0 then
                end
            elseif m.forwardVel < 10 then
                m.forwardVel = m.forwardVel + 1
            end
        end
        local stepResult = perform_air_step(m, 0)
    end

    if m.actionTimer == 0 then
        s.spinrev = 0
        s.lastPosX = m.pos.x
        s.lastPosZ = m.pos.z
       -- audio_sample_play(SOUND_SCD_PeeloutCharge, m.pos, 1)
    end
    m.actionTimer = m.actionTimer + 1
    if m.pos.y == m.floorHeight then
        play_step_sound(m, 9, 45)
        m.pos.x = s.lastPosX
        m.pos.z = s.lastPosZ
        m.marioObj.header.gfx.pos.x = s.lastPosX
        m.marioObj.header.gfx.pos.y = m.pos.y
        m.marioObj.header.gfx.pos.z = s.lastPosZ
    end

    if m.pos.y == m.floorHeight then
        print("hello")
        if (m.controller.buttonDown & U_JPAD) == 0  and m.actionTimer > 30 then
            --audio_sample_play(SOUND_SCD_PeeloutRelease, m.pos, 1)
            set_mario_action(m, ACT_WALKING, 0)
            m.forwardVel = s.spinrev
            set_camera_shake_from_hit(SHAKE_MED_DAMAGE)
            set_camera_shake_from_point(SHAKE_POS_MEDIUM, m.pos.x, m.pos.y, m.pos.z)
            m.particleFlags = m.particleFlags | PARTICLE_VERTICAL_STAR
            s.spinrev = 0
        end
        if m.pos.y < m.waterLevel - 100 then
            if s.spinrev >= 80 then
                s.spinrev = 80
            end
        end
        if s.spinrev < 128 then
            s.spinrev = s.spinrev + 5
        end
    end

    m.faceAngle.y = m.intendedYaw - approach_s32(convert_s16(m.intendedYaw - m.faceAngle.y), 0, 0x300, 0x300)
  set_mario_anim_with_accel(m, e.animation, s.spinrev / 5 * e.animSpeed)
    SetRunAnims(m, s.spinrev, s.spinrev)
    return
end
hook_mario_action(ACT_PEELOUT, act_peelout)

function SetRunAnims(m, Speed, NegSpeed)
    local s = gPlayerSyncTable[m.playerIndex]
    local e = gStateExtras[m.playerIndex]

    if Speed < 50 and Speed > 0 then
        e.animation = CHAR_ANIM_RUNNING_UNUSED
    elseif Speed >= 50 and Speed < 124 then
        e.animation = CHAR_ANIM_RUNNING
    elseif Speed >= 124 then
        e.animation = CHAR_ANIM_A_POSE
    end

    if NegSpeed > -50 and NegSpeed < -0 then
        e.animation = CHAR_ANIM_RUNNING_UNUSED
    elseif NegSpeed <= -50 and Speed > -124 then
        e.animation = CHAR_ANIM_RUNNING
    elseif NegSpeed <= -124 then
        e.animation = CHAR_ANIM_A_POSE
    end

    if e.animation == CHAR_ANIM_RUNNING_UNUSED then
       e.animSpeed = 0x10000
    elseif e.animation ~= CHAR_ANIM_A_POSE then
        e.animSpeed = 0x7000
    elseif e.animation == CHAR_ANIM_A_POSE then
        e.animSpeed = 0x10000
    end
    return
end
